package com.example;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;

import org.brotli.wrapper.Brotli;
import org.brotli.wrapper.dec.Decoder;
import org.brotli.wrapper.enc.Encoder;

public class Main {
	
	static {
		Brotli.loadLibrary();
	}
	
	public static void main(String[] args) throws Exception {

		//
		// 文字列を圧縮する
		//
		String s = "Hello, World!";
		byte[] b = s.getBytes();
		byte[] data = Encoder.compress(b);
		
		//
		// 圧縮したデータを展開する
		//
		byte[] b2 = Decoder.decompress(data);
		String s2 = new String(b2);
		System.out.println(s2);
		
		
		//
		// ファイルを圧縮する
		//
		File input  = new File("yahoo-top-page.html");
		File output = new File("yahoo-top-page.html.brotli");
		
		try(InputStream in = new FileInputStream(input);
				OutputStream out = new FileOutputStream(output)) {
			out.write(Encoder.compress(in.readAllBytes()));
		}
	}
}
